ENTRY(loader) /* name of the entry label */

SECTIONS {
    . = 0x00100000; /* code will be loaded at 1 MB */
    .text ALIGN(0x1000) : { *(.text) } /* aligned at 4 KB */
    .rodata ALIGN(0x1000) : { *(.rodata) } /* aligned at 4 KB */
    .data ALIGN(0x1000) : { *(.data) } /* aligned at 4 KB */
    .bss ALIGN(0x1000) : { *(COMMON) *(.bss) } /* aligned at 4 KB */
}
